# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ManagedIdentities.V1.Model.CheckMigrationPermissionResponse do
  @moduledoc """
  CheckMigrationPermissionResponse is the response message for CheckMigrationPermission method.

  ## Attributes

  *   `onpremDomains` (*type:* `list(GoogleApi.ManagedIdentities.V1.Model.OnPremDomainSIDDetails.t)`, *default:* `nil`) - The state of SID filtering of all the domains which has trust established.
  *   `state` (*type:* `String.t`, *default:* `nil`) - The state of DomainMigration.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :onpremDomains =>
            list(GoogleApi.ManagedIdentities.V1.Model.OnPremDomainSIDDetails.t()) | nil,
          :state => String.t() | nil
        }

  field(:onpremDomains,
    as: GoogleApi.ManagedIdentities.V1.Model.OnPremDomainSIDDetails,
    type: :list
  )

  field(:state)
end

defimpl Poison.Decoder, for: GoogleApi.ManagedIdentities.V1.Model.CheckMigrationPermissionResponse do
  def decode(value, options) do
    GoogleApi.ManagedIdentities.V1.Model.CheckMigrationPermissionResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ManagedIdentities.V1.Model.CheckMigrationPermissionResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
