# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ManagedIdentities.V1.Model.DomainJoinMachineRequest do
  @moduledoc """
  DomainJoinMachineRequest is the request message for DomainJoinMachine method

  ## Attributes

  *   `force` (*type:* `boolean()`, *default:* `nil`) - Optional. force if True, forces domain join even if the computer account already exists.
  *   `ouName` (*type:* `String.t`, *default:* `nil`) - Optional. OU name where the VM needs to be domain joined
  *   `vmIdToken` (*type:* `String.t`, *default:* `nil`) - Required. Full instance id token of compute engine VM to verify instance identity. More about this: https://cloud.google.com/compute/docs/instances/verifying-instance-identity#request_signature
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :force => boolean() | nil,
          :ouName => String.t() | nil,
          :vmIdToken => String.t() | nil
        }

  field(:force)
  field(:ouName)
  field(:vmIdToken)
end

defimpl Poison.Decoder, for: GoogleApi.ManagedIdentities.V1.Model.DomainJoinMachineRequest do
  def decode(value, options) do
    GoogleApi.ManagedIdentities.V1.Model.DomainJoinMachineRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ManagedIdentities.V1.Model.DomainJoinMachineRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
