# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ManagedIdentities.V1.Model.ExtendSchemaRequest do
  @moduledoc """
  ExtendSchemaRequest is the request message for ExtendSchema method.

  ## Attributes

  *   `description` (*type:* `String.t`, *default:* `nil`) - Required. Description for Schema Change.
  *   `fileContents` (*type:* `String.t`, *default:* `nil`) - File uploaded as a byte stream input.
  *   `gcsPath` (*type:* `String.t`, *default:* `nil`) - File stored in Cloud Storage bucket and represented in the form projects/{project_id}/buckets/{bucket_name}/objects/{object_name} File should be in the same project as the domain.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :description => String.t() | nil,
          :fileContents => String.t() | nil,
          :gcsPath => String.t() | nil
        }

  field(:description)
  field(:fileContents)
  field(:gcsPath)
end

defimpl Poison.Decoder, for: GoogleApi.ManagedIdentities.V1.Model.ExtendSchemaRequest do
  def decode(value, options) do
    GoogleApi.ManagedIdentities.V1.Model.ExtendSchemaRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ManagedIdentities.V1.Model.ExtendSchemaRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
