# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ManagedIdentities.V1.Model.OnPremDomainDetails do
  @moduledoc """
  OnPremDomainDetails is the message which contains details of on-prem domain which is trusted and needs to be migrated.

  ## Attributes

  *   `disableSidFiltering` (*type:* `boolean()`, *default:* `nil`) - Optional. Option to disable SID filtering.
  *   `domainName` (*type:* `String.t`, *default:* `nil`) - Required. FQDN of the on-prem domain being migrated.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :disableSidFiltering => boolean() | nil,
          :domainName => String.t() | nil
        }

  field(:disableSidFiltering)
  field(:domainName)
end

defimpl Poison.Decoder, for: GoogleApi.ManagedIdentities.V1.Model.OnPremDomainDetails do
  def decode(value, options) do
    GoogleApi.ManagedIdentities.V1.Model.OnPremDomainDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ManagedIdentities.V1.Model.OnPremDomainDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
